<?php

/**
 * NOTICE OF LICENSE.
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 * @author    www.mergado.cz
 * @copyright 2016 Mergado technologies, s. r. o.
 * @license   LICENSE.txt
 */

namespace Mergado\Tools;

use Mergado\Biano\BianoStarService;
use Mergado\Includes\Services\ArukeresoFamily\Arukereso\ArukeresoService;
use Mergado\Includes\Services\ArukeresoFamily\Compari\CompariService;
use Mergado\Includes\Services\ArukeresoFamily\Pazaruvaj\PazaruvajService;
use Mergado\Biano\BianoService;
use Mergado\Etarget\EtargetService;
use Mergado\Facebook\FacebookService;
use Mergado\Glami\GlamiPixelService;
use Mergado\Glami\GlamiTopService;
use Mergado\Google\GoogleAdsService;
use Mergado\Google\GoogleAnalyticsRefundService;
use Mergado\Google\GoogleReviewsService;
use Mergado\Google\GoogleTagManagerService;
use Mergado\NajNakup\NajNakupService;
use Mergado\Pricemania\PricemaniaService;
use Mergado\Zbozi\ZboziService;

include_once __MERGADO_DIR__ . 'autoload.php';

class Settings
{
    const KELKOO = array(
        'ACTIVE' => 'kelkoo_active',
        'COM_ID' => 'kelkoo_merchant_id',
        'COUNTRY' => 'kelkoo_country',
        'CONVERSION_VAT_INCL' => 'kelkoo-vat-included',
    );

    const KELKOO_COUNTRIES = array(
        array('id_option' => 1, 'name' => 'Austria', 'type_code' => 'at'),
        array('id_option' => 2, 'name' => 'Belgium', 'type_code' => 'be'),
        array('id_option' => 3, 'name' => 'Brazil', 'type_code' => 'br'),
        array('id_option' => 4, 'name' => 'Switzerland', 'type_code' => 'ch'),
        array('id_option' => 5, 'name' => 'Czech Republic', 'type_code' => 'cz'),
        array('id_option' => 6, 'name' => 'Germany', 'type_code' => 'de'),
        array('id_option' => 7, 'name' => 'Denmark', 'type_code' => 'dk'),
        array('id_option' => 8, 'name' => 'Spain', 'type_code' => 'es'),
        array('id_option' => 9, 'name' => 'Finland', 'type_code' => 'fi'),
        array('id_option' => 10, 'name' => 'France', 'type_code' => 'fr'),
        array('id_option' => 11, 'name' => 'Ireland', 'type_code' => 'ie'),
        array('id_option' => 12, 'name' => 'Italy', 'type_code' => 'it'),
        array('id_option' => 13, 'name' => 'Mexico', 'type_code' => 'mx'),
        array('id_option' => 14, 'name' => 'Flemish Belgium', 'type_code' => 'nb'),
        array('id_option' => 15, 'name' => 'Netherlands', 'type_code' => 'nl'),
        array('id_option' => 16, 'name' => 'Norway', 'type_code' => 'no'),
        array('id_option' => 17, 'name' => 'Poland', 'type_code' => 'pl'),
        array('id_option' => 18, 'name' => 'Portugal', 'type_code' => 'pt'),
        array('id_option' => 19, 'name' => 'Russia', 'type_code' => 'ru'),
        array('id_option' => 20, 'name' => 'Sweden', 'type_code' => 'se'),
        array('id_option' => 21, 'name' => 'United Kingdom', 'type_code' => 'uk'),
        array('id_option' => 22, 'name' => 'United States', 'type_code' => 'us'),
    );

    const SKLIK = [
        'CONVERSION_ACTIVE' => 'sklik-form-conversion-active',
        'RETARGETING_ACTIVE' => 'sklik-form-retargeting-active',
        'CONVERSION_CODE' => 'sklik-form-conversion-code',
        'CONVERSION_VALUE' => 'sklik-form-conversion-value',
        'RETARGETING_ID' => 'sklik-form-retargeting-id',
        'CONVERSION_VAT_INCL' => 'sklik-vat-included',
    ];

    const GOOGLE_GTAGJS = array(
        'ACTIVE' => 'mergado_google_analytics_active',
        'CODE' => 'mergado_google_analytics_code',
        'TRACKING' => 'mergado_google_analytics_tracking',
        'ECOMMERCE' => 'mergado_google_analytics_ecommerce',
        'ECOMMERCE_ENHANCED' => 'mergado_google_analytics_ecommerce_enhanced',
        'CONVERSION_VAT_INCL' => 'gtagjs-vat-included',
    );

    const HEUREKA = [
        //Verified
        'ACTIVE_CZ' => 'heureka-verified-cz-form-active',
        'ACTIVE_SK' => 'heureka-verified-sk-form-active',
        'VERIFIED_CZ' => 'heureka-verified-cz-form-code',
        'VERIFIED_SK' => 'heureka-verified-sk-form-code',

        //Verified - WIDGET
        'WIDGET_CZ' => 'heureka-widget-cz-form-active',
        'WIDGET_CZ_ID' => 'heureka-widget-cz-id',
        'WIDGET_CZ_POSITION' => 'heureka-widget-cz-position',
        'WIDGET_CZ_MARGIN' => 'heureka-widget-cz-margin',
        'WIDGET_CZ_SHOW_MOBILE' => 'heureka-widget-cz-show-mobile',
        'WIDGET_CZ_HIDE_WIDTH' => 'heureka-widget-cz-hide-width',
        'WIDGET_SK' => 'heureka-widget-sk-form-active',
        'WIDGET_SK_ID' => 'heureka-widget-sk-id',
        'WIDGET_SK_POSITION' => 'heureka-widget-sk-position',
        'WIDGET_SK_MARGIN' => 'heureka-widget-sk-margin',
        'WIDGET_SK_SHOW_MOBILE' => 'heureka-widget-sk-show-mobile',
        'WIDGET_SK_HIDE_WIDTH' => 'heureka-widget-sk-hide-width',

        //Tracking
        'ACTIVE_TRACK_CZ' => 'heureka-track-cz-form-active',
        'ACTIVE_TRACK_SK' => 'heureka-track-sk-form-active',
        'TRACK_CODE_CZ' => 'heureka-track-cz-form-code',
        'TRACK_CODE_SK' => 'heureka-track-sk-form-code',

        // Other - feed
        'STOCK_FEED' => 'heureka-stock-feed-form-active',
        'CONVERSION_VAT_INCL_CZ' => 'heureka-vat-cz-included',
        'CONVERSION_VAT_INCL_SK' => 'heureka-vat-sk-included',
    ];

    const IMPORT = [
        'LAST_UPDATE' => 'mergado_last_prices_import',
        'COUNT' => 'import-form-products'
    ];

    const CRONS = [
        'ACTIVE_PRODUCT_FEED' => 'wp-cron-product-feed-active',
        'ACTIVE_STOCK_FEED' => 'wp-cron-stock-feed-active',
        'ACTIVE_CATEGORY_FEED' => 'wp-cron-category-feed-active',
        'ACTIVE_IMPORT_FEED' => 'wp-cron-import-feed-active',
        'SCHEDULE_PRODUCT_FEED' => 'wp-cron-product-feed-schedule',
        'SCHEDULE_STOCK_FEED' => 'wp-cron-stock-feed-schedule',
        'SCHEDULE_CATEGORY_FEED' => 'wp-cron-category-feed-schedule',
        'SCHEDULE_IMPORT_FEED' => 'wp-cron-import-feed-schedule',
        'START_PRODUCT_FEED' => 'wp-cron-product-feed-start',
        'START_STOCK_FEED' => 'wp-cron-stock-feed-start',
        'START_CATEGORY_FEED' => 'wp-cron-category-feed-start',
        'START_IMPORT_FEED' => 'wp-cron-import-feed-start',
    ];

    const OPTIMIZATION = [
        'PRODUCT_FEED' => 'feed-form-products',
        'STOCK_FEED' => 'feed-form-stock',
        'CATEGORY_FEED' => 'feed-form-category',
        'IMPORT_FEED' => 'import-form-products',
    ];

    const WIZARD = [
        'FINISHED_PRODUCT' => 'mmp-wizard-finished-product',
        'FINISHED_STOCK' => 'mmp-wizard-finished-stock',
        'FINISHED_CATEGORY' => 'mmp-wizard-finished-category',
        'FINISHED_IMPORT' => 'mmp-wizard-finished-import',
    ];

    const COOKIE_FIRST_RATING = 'mmp-cookie-first-rating';
    const COOKIE_RATING = 'mmp-cookie-rating';
    const COOKIE_NEWS = 'mmp-cookie-news';

	const WP_CRON_FORCED = 'mmp-wp-cron-forced'; // enable wp cron forms even with DISABLE_WP_CRON = true in wp-config.php

    /*******************************************************************************************************************
     * SAVE OPTIONS
     *******************************************************************************************************************/

    /**
     * @param $post
     * @param array $checkboxes
     * @param array $inputs
     * @param array|null $selectboxes
     */

    public static function saveOptions($post, array $checkboxes, array $inputs = [], array $selectboxes = null)
    {

        $logger = wc_get_logger();

        // Log if changed
        foreach ($checkboxes as $checkbox) {

            // Log if changed
            if (isset($post[$checkbox])) {
                if (get_option($checkbox) !== str_replace('off', '0', str_replace('on', '1', $post[$checkbox])) && isset($post[$checkbox])) {
                    $logger->info('OPTION CHANGED: ' . $checkbox . ' changed to ' . $post[$checkbox]);
                } elseif (get_option($checkbox) !== '' && !isset($post[$checkbox])) {
                    $logger->info('OPTION CHANGED: ' . $checkbox . ' changed to off');
                }
            }

            // Save
            if (isset($post[$checkbox]) && $post[$checkbox] === 'on') {
                update_option($checkbox, 1);

                // Schedule or remove cron from wp_cron
                if (strpos($checkbox, 'wp-cron-') !== false && strpos($checkbox, '-active') !== false) {
                    $name = explode('-active', $checkbox)[0];
                    // first start is disabled in cron settings from v3.0
                    // Crons::addTask($name, $post[$name . '-schedule'], $post[$name . '-start']);
                    Crons::addTask($name, $post[$name . '-schedule'], '');
                }
            } else {
                update_option($checkbox, 0);

                // Schedule or remove cron from wp_cron
                if (strpos($checkbox, 'wp-cron-') !== false && strpos($checkbox, '-active') !== false) {
                    $name = explode('-active', $checkbox)[0];
                    Crons::removeTask($name);
                }
            }
        }

	    if ($inputs !== null) {
		    foreach ( $inputs as $input ) {
			    // Log if changed
			    if ( ( isset( $input ) && isset( $post[ $input ] ) ) && get_option( $input ) !== $post[ $input ] ) {
				    $logger->info( 'OPTION CHANGED: ' . $input . ' changed to ' . $post[ $input ] );

				    if ( $input === Settings::OPTIMIZATION['PRODUCT_FEED'] ) {
					    update_option( XMLClass::FEED_COUNT['PRODUCT'], 0 );

					    $files = glob( __MERGADO_TMP_DIR__ . Settings::getCurrentBlogId() . '/productFeed/*' );

					    foreach ( $files as $file ) {
						    if ( is_file( $file ) ) {
							    unlink( $file );
						    }
					    }
				    } else if ( $input === Settings::OPTIMIZATION['CATEGORY_FEED'] ) {
					    update_option( XMLClass::FEED_COUNT['CATEGORY'], 0 );

					    $files = glob( __MERGADO_TMP_DIR__ . Settings::getCurrentBlogId() . '/categoryFeed/*' );

					    foreach ( $files as $file ) {
						    if ( is_file( $file ) ) {
							    unlink( $file );
						    }
					    }
				    } else if ( $input === Settings::OPTIMIZATION['STOCK_FEED'] ) {
					    update_option( XMLClass::FEED_COUNT['STOCK'], 0 );

					    $files = glob( __MERGADO_TMP_DIR__ . Settings::getCurrentBlogId() . '/stockFeed/*' );

					    foreach ( $files as $file ) {
						    if ( is_file( $file ) ) {
							    unlink( $file );
						    }
					    }
				    }

			    }

			    if ( isset( $post[ $input ] ) ) {
				    update_option( $input, trim( $post[ $input ] ) );
			    }
		    }
	    }

        if ($selectboxes !== null) {
            foreach ($selectboxes as $select) {
                // Log if changed
                if ((isset($select) && isset($post[$select])) && get_option($select) !== $post[$select]) {
                    $logger->info('OPTION CHANGED: ' . $select . ' changed to ' . $post[$select]);
                }

                if (isset($post[$select])) {
                    update_option($select, $post[$select]);
                }
            }
        }
    }

    /**
     * Return current blog ID
     * - Due of compatibility returning '' for non multisite (in future change to 0)
     * @return int|string
     */

    public static function getCurrentBlogId()
    {
        if (is_multisite()) {
            $currentBlogId = get_current_blog_id();
        } else {
            $currentBlogId = 0;
        }

        return $currentBlogId;
    }

    public static function getInformationsForSupport()
    {
        $xmlProductFeed = new XMLProductFeed();
        $xmlCategoryFeed = new XMLCategoryFeed();
        $xmlStockFeed = new XMLStockFeed();
        $importPricesClass = new ImportPricesClass();
        $googleAdsService = new GoogleAdsService();
        $googleTagManagerService = new GoogleTagManagerService();
        $googleReviewsService = new GoogleReviewsService();
        $arukeresoService = new ArukeresoService();
        $compariService = new CompariService();
        $pazaruvajService = new PazaruvajService();
        $glamiPixelService = new GlamiPixelService();
        $glamiTopService = new GlamiTopService();
        $zboziService = new ZboziService();
        $facebookService = new FacebookService();
		$etargetService = new EtargetService();
		$najNakupService = new NajNakupService();
		$pricemaniaService = new PricemaniaService();
		$bianoService = new BianoService();
        $bianoStarService = new BianoStarService();

        if (class_exists('WooCommerce')) {
            global $woocommerce;
            $woocomerceVersion = $woocommerce->version;
        } else {
            $woocomerceVersion = __('Not available', 'mergado-marketing-pack');
        }

        return [
            'base' => [
                'web_url' => [
                    'name' => __('Web URL', 'mergado-marketing-pack'),
                    'value' => get_site_url(),
                ],
                'token' => [
                    'name' => __('Token', 'mergado-marketing-pack'),
                    'value' => get_option('mmp_token'),
                ],
                'wp_version' => [
                    'name' => __('WP version', 'mergado-marketing-pack'),
                    'value' => get_bloginfo('version'),
                ],
                'wc_version' => [
                    'name' => __('WC version', 'mergado-marketing-pack'),
                    'value' => $woocomerceVersion,
                ],
                'mp_version' => [
                    'name' => __('MP version', 'mergado-marketing-pack'),
                    'value' => PLUGIN_VERSION,
                ],
                'php' => [
                    'name' => __('PHP', 'mergado-marketing-pack'),
                    'value' => phpversion(),
                ],
                'product_feed_url' => [
                    'name' => __('Product feed URL', 'mergado-marketing-pack'),
                    'value' => $xmlProductFeed->getFeedUrl(),
                ],
                'product_cron_url' => [
                    'name' => __('Product cron URL', 'mergado-marketing-pack'),
                    'value' => $xmlProductFeed->getCronUrl(),
                ],
                'product_feed_last_change' => [
                    'name' => __('Product feed last change time', 'mergado-marketing-pack'),
                    'value' => $xmlProductFeed->getLastFeedChange(),
                ],
                'product_wp_cron_active' => [
                    'name' => __('WP product cron - status', 'mergado-marketing-pack'),
                    'value' => self::boolToActive($xmlProductFeed->isWpCronActive()),
                ],
                'product_wp_cron_schedule' => [
                    'name' => __('WP product cron - schedule', 'mergado-marketing-pack'),
                    'value' => Crons::getTaskByVariable($xmlProductFeed->getCronSchedule()),
                ],
                'category_feed_url' => [
                    'name' => __('Category feed URL', 'mergado-marketing-pack'),
                    'value' => $xmlCategoryFeed->getFeedUrl(),
                ],
                'category_cron_url' => [
                    'name' => __('Category cron URL', 'mergado-marketing-pack'),
                    'value' => $xmlCategoryFeed->getCronUrl(),
                ],
                'category_wp_cron_active' => [
                    'name' => __('WP category cron - status', 'mergado-marketing-pack'),
                    'value' => self::boolToActive($xmlCategoryFeed->isWpCronActive()),
                ],
                'category_wp_cron_schedule' => [
                    'name' => __('WP category cron - schedule', 'mergado-marketing-pack'),
                    'value' => Crons::getTaskByVariable($xmlCategoryFeed->getCronSchedule()),
                ],
                'stock_feed_url' => [
                    'name' => __('Stock feed URL', 'mergado-marketing-pack'),
                    'value' => $xmlStockFeed->getFeedUrl(),
                ],
                'stock_cron_url' => [
                    'name' => __('Stock cron URL', 'mergado-marketing-pack'),
                    'value' => $xmlStockFeed->getCronUrl(),
                ],
                'stock_wp_cron_active' => [
                    'name' => __('WP stock cron - status', 'mergado-marketing-pack'),
                    'value' => self::boolToActive($xmlStockFeed->isWpCronActive()),
                ],
                'stock_wp_cron_schedule' => [
                    'name' => __('WP stock cron - schedule', 'mergado-marketing-pack'),
                    'value' => Crons::getTaskByVariable($xmlStockFeed->getCronSchedule()),
                ],
                'import_feed_url' => [
                    'name' => __('Import prices feed URL', 'mergado-marketing-pack'),
                    'value' => $importPricesClass->getImportUrl(),
                ],
                'import_cron_url' => [
                    'name' => __('Import prices cron URL', 'mergado-marketing-pack'),
                    'value' => $importPricesClass->getCronUrl(),
                ],
                'import_wp_cron_active' => [
                    'name' => __('WP import cron - status', 'mergado-marketing-pack'),
                    'value' => self::boolToActive($importPricesClass->isWpCronActive()),
                ],
                'import_wp_cron_schedule' => [
                    'name' => __('WP import cron - schedule', 'mergado-marketing-pack'),
                    'value' => Crons::getTaskByVariable($importPricesClass->getCronSchedule()),
                ],
            ],
            'adsystems' => [
                'googleAds' => self::boolToActive($googleAdsService->getConversionActive()),
                'googleAdsRemarketing' => self::boolToActive($googleAdsService->getRemarketingActive()),
                'googleAnalytics' => self::boolToActive(get_option(Settings::GOOGLE_GTAGJS['ACTIVE'], 0)),
                'googleAnalyticsRefunds' => self::boolToActive(get_option(GoogleAnalyticsRefundService::ACTIVE, 0)),
                'googleTagManager' => self::boolToActive($googleTagManagerService->getActive()),
                'googleTagManagerEcommerce' => self::boolToActive($googleTagManagerService->getEcommerceActive()),
                'googleTagManagerEnhancedEcommerce' => self::boolToActive($googleTagManagerService->getEnhancedEcommerceActive()),
                'googleCustomerReviews' => self::boolToActive($googleReviewsService->getOptInActive()),
                'googleCustomerReviewsBadge' => self::boolToActive($googleReviewsService->getBadgeActive()),
                'facebookPixel' => self::boolToActive($facebookService->getActive()),
                'heurekaVerify' => self::boolToActive(get_option(Settings::HEUREKA['ACTIVE_CZ'], 0)),
                'heurekaVerifyWidget' => self::boolToActive(get_option(Settings::HEUREKA['WIDGET_CZ'], 0)),
                'heurekaConversions' => self::boolToActive(get_option(Settings::HEUREKA['ACTIVE_TRACK_CZ'], 0)),
                'heurekaVerifySk' => self::boolToActive(get_option(Settings::HEUREKA['ACTIVE_SK'], 0)),
                'heurekaVerifySkWidget' => self::boolToActive(get_option(Settings::HEUREKA['WIDGET_SK'], 0)),
                'heurekaConversionsSk' => self::boolToActive(get_option(Settings::HEUREKA['ACTIVE_TRACK_SK'], 0)),
                'glamiPixel' => self::boolToActive($glamiPixelService->getActive()),
                'glamiTop' => self::boolToActive($glamiTopService->getActive()),
                'sklik' => self::boolToActive(get_option(Settings::SKLIK['CONVERSION_ACTIVE'], 0)),
                'sklikRetargeting' => self::boolToActive(get_option(Settings::SKLIK['RETARGETING_ACTIVE'], 0)),
                'zbozi' => self::boolToActive($zboziService->getActive()),
                'etarget' => self::boolToActive($etargetService->getActive()),
                'najnakup' => self::boolToActive($najNakupService->getActive()),
                'pricemania' => self::boolToActive($pricemaniaService->getActive()),
                'kelkoo' => self::boolToActive(get_option(Settings::KELKOO['ACTIVE'], 0)),
                'biano' => self::boolToActive($bianoService->getActive()),
                'bianoStar' => self:: boolToActive($bianoStarService->getActive()),
                'arukereso' => self::boolToActive($arukeresoService->getActive()),
                'arukeresoWidget' => self::boolToActive($arukeresoService->getWidgetActive()),
                'compari' => self::boolToActive($compariService->getActive()),
                'compariWidget' => self::boolToActive($compariService->getWidgetActive()),
                'pazaruvaj' => self::boolToActive($pazaruvajService->getActive()),
                'pazaruvajWidget' => self::boolToActive($pazaruvajService->getWidgetActive()),
            ]

        ];
    }

    public static function boolToActive($bool)
    {
        if ($bool) {
            return 'active';
        } else {
            return 'inactive';
        }
    }

    public static function getScheduleEstimate($currentProductsPerStep, $totalProducts, $cronSchedule)
    {

	    if ($currentProductsPerStep == 0 || trim($currentProductsPerStep) === '') {
	    	$currentProductsPerStep = $totalProducts;
	    }

	    $numberOfRuns = $totalProducts / $currentProductsPerStep;
	    $scheduleSeconds = Crons::getScheduleInSeconds($cronSchedule);

	    $totalTimeToGenerate = $numberOfRuns * $scheduleSeconds;

	    if ($totalTimeToGenerate < $scheduleSeconds) {
	    	return self::human_time_diff_mmp(0, $scheduleSeconds);
	    } else {
		    return self::human_time_diff_mmp(0, $totalTimeToGenerate);
	    }
    }

	/**
	 * Determines the difference between two timestamps.
	 *
	 * The difference is returned in a human readable format such as "1 hour",
	 * "5 mins", "2 days".
	 *
	 * @since 1.5.0
	 * @since 5.3.0 Added support for showing a difference in seconds.
	 *
	 * @param int $from Unix timestamp from which the difference begins.
	 * @param int $to   Optional. Unix timestamp to end the time difference. Default becomes time() if not set.
	 * @return string Human readable time difference.
	 */
	public static function human_time_diff_mmp( $from, $to = 0 ) {
		if ( empty( $to ) ) {
			$to = time();
		}

		$diff = (int) abs( $to - $from );

		if ( $diff < MINUTE_IN_SECONDS ) {
			$secs = $diff;
			if ( $secs <= 1 ) {
				$secs = 1;
			}
			/* translators: Time difference between two dates, in seconds. %s: Number of seconds. */
			$since = sprintf( _n( '%s second', '%s seconds', $secs, 'mergado-marketing-pack' ), $secs );
		} elseif ( $diff < HOUR_IN_SECONDS && $diff >= MINUTE_IN_SECONDS ) {
			$mins = round( $diff / MINUTE_IN_SECONDS );
			if ( $mins <= 1 ) {
				$mins = 1;
			}
			/* translators: Time difference between two dates, in minutes (min=minute). %s: Number of minutes. */
			$since = sprintf( _n( '%s min', '%s mins', $mins, 'mergado-marketing-pack' ), $mins );
		} elseif ( $diff < DAY_IN_SECONDS && $diff >= HOUR_IN_SECONDS ) {
			$hours = round( $diff / HOUR_IN_SECONDS );
			if ( $hours <= 1 ) {
				$hours = 1;
			}
			/* translators: Time difference between two dates, in hours. %s: Number of hours. */
			$since = sprintf( _n( '%s hour', '%s hours', $hours, 'mergado-marketing-pack' ), $hours );
		} elseif ( $diff < WEEK_IN_SECONDS && $diff >= DAY_IN_SECONDS ) {
			$days = round( $diff / DAY_IN_SECONDS );
			if ( $days <= 1 ) {
				$days = 1;
			}
			/* translators: Time difference between two dates, in days. %s: Number of days. */
			$since = sprintf( _n( '%s day', '%s days', $days, 'mergado-marketing-pack' ), $days );
		} elseif ( $diff < MONTH_IN_SECONDS && $diff >= WEEK_IN_SECONDS ) {
			$weeks = round( $diff / WEEK_IN_SECONDS );
			if ( $weeks <= 1 ) {
				$weeks = 1;
			}
			/* translators: Time difference between two dates, in weeks. %s: Number of weeks. */
			$since = sprintf( _n( '%s week', '%s weeks', $weeks, 'mergado-marketing-pack' ), $weeks );
		} elseif ( $diff < YEAR_IN_SECONDS && $diff >= MONTH_IN_SECONDS ) {
			$months = round( $diff / MONTH_IN_SECONDS );
			if ( $months <= 1 ) {
				$months = 1;
			}
			/* translators: Time difference between two dates, in months. %s: Number of months. */
			$since = sprintf( _n( '%s month', '%s months', $months, 'mergado-marketing-pack' ), $months );
		} elseif ( $diff >= YEAR_IN_SECONDS ) {
			$years = round( $diff / YEAR_IN_SECONDS );
			if ( $years <= 1 ) {
				$years = 1;
			}
			/* translators: Time difference between two dates, in years. %s: Number of years. */
			$since = sprintf( _n( '%s year', '%s years', $years, 'mergado-marketing-pack' ), $years );
		}

		/**
		 * Filters the human readable difference between two timestamps.
		 *
		 * @since 4.0.0
		 *
		 * @param string $since The difference in human readable text.
		 * @param int    $diff  The difference in seconds.
		 * @param int    $from  Unix timestamp from which the difference begins.
		 * @param int    $to    Unix timestamp to end the time difference.
		 */
		return apply_filters( 'human_time_diff', $since, $diff, $from, $to );
	}
}
