<?php

namespace Mergado\Tools\XML;

use Mergado\Tools\Settings;

class OtherFeedVisibilityService extends AbstractFeedVisibilityService
{
    private const FEED_TYPE = 'other';
    private static $instance;

    protected function __construct()
    {
        parent::__construct(self::FEED_TYPE);
    }

    /**
     * @return OtherFeedVisibilityService
     */
    public static function getInstance()
    {
        if (!isset(self::$instance)) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    /*******************************************************************************************************************
     * SAVE FIELDS
     ******************************************************************************************************************/

    /**
     * @param $post
     */
    public static function saveFields($post)
    {
        $checkboxes = [];

        foreach(self::getInstance()->baseVisibilityOptions as $item) {
            $checkboxes[] = $item['databaseName'];
        }

        foreach(self::getInstance()->catalogVisibilityOptions as $item) {
            $checkboxes[] = $item['databaseName'];
        }

        Settings::saveOptions($post,
            $checkboxes
        );
    }
}
